module TFTP
  # An exception raised by TFTP code.
  class Error < StandardError
    
    MESSAGES = {
      :invalid_block_num    => "Block nums must begin with 1 and increase by one for each new block of data.",
      :no_filename_provided => "All RRQ/WRQ packets are required to have a filename.",
      :unsupported_mode => "Octet is the only mode currently supported."
    }

    def self.message(key, *args)
      string = MESSAGES[key] or raise "[TFTP BUG] No error messages for #{key}"
      (args.empty? ? string : string % args).rstrip
    end

    # @param message [String] The error message
    def initialize(message = nil)
      super(message)
    end

  end
end
